'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

function createContainer(defaultState) {
  var _class, _temp2;

  var Context = React.createContext({
    state: Object.assign({}, defaultState),
    setState: function setState() {}
  });

  return _temp2 = _class = function (_React$Component) {
    inherits(Container, _React$Component);

    function Container() {
      var _ref;

      var _temp, _this, _ret;

      classCallCheck(this, Container);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = Container.__proto__ || Object.getPrototypeOf(Container)).call.apply(_ref, [this].concat(args))), _this), _this.state = Object.assign({}, defaultState), _this.setState = _this.setState.bind(_this), _this._value = {}, _temp), possibleConstructorReturn(_this, _ret);
    }

    createClass(Container, [{
      key: "render",
      value: function render() {
        return React.createElement(
          Context.Provider,
          { value: this.value },
          typeof this.props.children === "function" ? React.createElement(
            Context.Consumer,
            null,
            this.props.children
          ) : this.props.children
        );
      }
    }, {
      key: "value",
      get: function get$$1() {
        if (this._value.state !== this.state) {
          this._value = {
            state: this.state,
            setState: this.setState
          };
        }

        return this._value;
      }
    }]);
    return Container;
  }(React.Component), _class.Consumer = Context.Consumer, _temp2;
}

var Container = createContainer();

exports.createContainer = createContainer;
exports.Container = Container;
